Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

Module RAIxx

    '
    ' Device status (Return value)
    '
    Public Const RAI_OK As Integer = 0
    Public Const RAI_INVALID_HANDLE As Integer = 1
    Public Const RAI_DEVICE_NOT_FOUND As Integer = 2
    Public Const RAI_DEVICE_NOT_OPENED As Integer = 3
    Public Const RAI_OTHER_ERROR As Integer = 4
    Public Const RAI_COMMUNICATION_ERROR As Integer = 5
    Public Const RAI_INVALID_PARAMETER As Integer = 6
    Public Const RAI_MEMORY_ERROR As Integer = 7

    '
    ' Sampling Rate
    '
    Public Const RAI_SAMPLING_RATE_10KSPS As Integer = 1
    Public Const RAI_SAMPLING_RATE_1KSPS As Integer = 10
    Public Const RAI_SAMPLING_RATE_100SPS As Integer = 100
    Public Const RAI_SAMPLING_RATE_10SPS As Integer = 1000

    '
    ' Trigger CH
    '
    Public Const RAI_TRIGGER_CH0 As Byte = 0
    Public Const RAI_TRIGGER_CH1 As Byte = 1
    Public Const RAI_TRIGGER_CH2 As Byte = 2
    Public Const RAI_TRIGGER_CH3 As Byte = 3

    '
    ' Trigger Type
    '
    Public Const RAI_TRIGGER_TYPE_LEVEL_H As Byte = 0
    Public Const RAI_TRIGGER_TYPE_LEVEL_L As Byte = 1
    Public Const RAI_TRIGGER_TYPE_SLOPE_RISING As Byte = 2
    Public Const RAI_TRIGGER_TYPE_SLOPE_FALLING As Byte = 3


    '
    ' Device Functions
    '
    Public Declare Function RAI_GetNumberOfDevices Lib "RAIxx.dll" (ByRef Number As Integer) As Integer
    Public Declare Function RAI_GetSerialNumber Lib "RAIxx.dll" (ByVal Index As Integer, ByRef SerialNumber As Integer) As Integer
    Public Declare Function RAI_Open Lib "RAIxx.dll" (ByRef ID As Byte) As Integer
    Public Declare Function RAI_OpenBySerialNumber Lib "RAIxx.dll" (ByVal SerialNumber As Integer, ByRef ID As Byte) As Integer
    Public Declare Function RAI_Close Lib "RAIxx.dll" (ByVal ID As Byte) As Integer

    '
    ' A/D Functions
    '
    Public Declare Function RAI_GetAnalogVoltage Lib "RAIxx.dll" (ByVal ID As Byte, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH0Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH1Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH2Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH3Value As Object, ByVal SamplingCount As Integer) As Integer
    Public Declare Function RAI_GetAnalogVoltageEx Lib "RAIxx.dll" (ByVal ID As Byte, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH0Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH1Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH2Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH3Value As Object, ByVal SamplingRate As Integer, ByVal SamplingCount As Integer) As Integer
    Public Declare Function RAI_GetAnalogVoltageExEx Lib "RAIxx.dll" (ByVal ID As Byte, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH0Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH1Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH2Value As Object, <MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()> ByVal CH3Value As Object, ByVal SamplingRate As Integer, ByVal SamplingCount As Integer, ByRef ReadCount As Integer, ByVal TriggerCH As Byte, ByVal TriggerType As Byte, ByVal TriggerThreshold As Double, ByVal TriggerWaitCount As Integer) As Integer

End Module
